| Enumerations, structures and type definitions

### CalcScreenFormat

SCREEN_FULL,

An enumeration which contains the following calculator types: /

Return value : |

### CalcPixelFormat

CALC_PIXFMT_MONO = 1, // Monochrome (1 bpp)

An enumeration which defines the format of screenshot images:

Return value : |

### CalcPathType

PATH_FULL,

An enumeration which contains the path type: /

Return value : |

### CalcMemType

MEMORY_NONE = 0,

An enumeration which contains the different memory sizes: /

Return value : |

### CalcMode

MODE_NORMAL = 0,

An enumeration which contains different mask modes: /

Return value : |

### CalcRomDumpSize

ROMSIZE_AUTO = 0,

An enumeration which contains the following ROM dump sizes: /

Return value : |

### CalcShellType

SHELL_NONE = 4,

An enumeration which contains the shell to use with ROM dumping: /

Return value : |

### CalcProductIDs

PRODUCT_ID_NONE = 0x00,

An enumeration which contains the product IDs used by TI graphing calculators: /

Return value : |

### CalcOperations

FTS_NONE = 0,

An enumeration which contains the different supported operations: /

Return value : |

### CalcAction

ACT_NONE = 0,

An enumeration which contains the action taken on a variable /

Return value : |

### InfosMask

INFOS_PRODUCT_NUMBER = (1 << 0), /* obsolete (never used) */

An enumeration which contains the different flags supported by CalcInfos: /

Return value : |

### CalcFnctsIdx

// TODO for next gen CALC_ prefix.

Index of function in the #CalcFncts structure: /

Return value : |

### TigMode

TIG_NONE = 0,

An enumeration which contains the data to save in tigroup: /

Return value : |

### DBUSPacket

uint16_t length; ///< data length

Packet for the DBUS (old calculators) protocol. /

Return value : |

### DUSBRawPacket

uint32_t size; ///< raw packet size

Raw packet for the DUSB / CARS (84+(SE), 89T) protocol. /

Return value : |

### DUSBVirtualPacket

uint32_t size; ///< virtual packet size

Virtual packet for the DUSB / CARS (84+(SE), 89T) protocol. /

Return value : |

### NSPRawPacket

uint16_t unused;

Raw packet for the Nspire NavNet protocol. /

Return value : |

### NSPVirtualPacket

uint16_t src_addr;

Virtual packet for the Nspire NavNet protocol. /

Return value : |

### ROMDumpRawPacket

uint16_t length; ///< data length

Packet for libticalcs' ROM dump protocol. /

Return value : |

### CalcScreenCoord

int format;

A structure used for storing screen size. /

format : | returns full or clipped image (#CalcScreenFormat)
width : | real width
height : | real height
clipped_width : | clipped width (89 for instance)
clipped_height : | clipped height (89 for instance)
pixel_format : | format of pixel data (#CalcPixelFormat)
Return value : |

### TreeInfo

CalcModel model;

A structure used for storing information about a directory list tree. /

model : | hand-held model
type : | var or app list (VAR_NODE_NAME or APP_NODE_NAME)
mem_used : | memory used (depends on hand-held model)
mem_free : | memory free (depends on hand-held model)
Return value : |

### KeyPair

const char* name;

A structure which contains a TI scancode. /

name : | name of key (like "ESC")
value : | value of key (like 264)
Return value : |

### CalcKey

const char* key_name;

A structure which contains a TI scancode with key modifiers. /

key_name : | name of key
normal : | information for key when pressed without modifiers
shift : | information for key when pressed with SHIFT modifier (TI-68k series)
second : | information for key when pressed with 2nd modifier (TI-Z80 & TI-68k series)
diamond : | information for key when pressed with DIAMOND modifier (TI-68k series)
alpha : | information for key when pressed with ALPHA modifier (TI-Z80 & TI-68k series)
Return value : |

### CalcClock

uint16_t year;

A structure used for clock management. /

year : | year
month: : | (null)
day: : | (null)
hours: : | (null)
minutes: : | (null)
seconds: : | (null)
time_format : | 12 or 24
date_format : | 1 or 6
Return value : |

### CalcUpdate

char text[256];

Refresh/progress functions This structure allows to implement a kind of callbacks mechanism (which allow libCalcs to interact with user without being dependant of a GUI). /

text : | a text to display about the current operation (locale used is those defined by tifiles_transcoding_set)
cancel : | set to 1 if transfer have to be cancelled
rate : | data rate of cable
cnt1 : | current counter for link transfer operations (ticalcs2 only)
max1 : | max value of this counter
cnt2 : | current count for intermediate operations (ticalcs2 only)
max2 : | max value of this counter
cnt3 : | current counter for global operations (used by ticalcs2 or tilp)
max3 : | max value of this counter
mask : | which cntX is/are used (unused)
type : | pbar type (unused)
start : | init internal vars
stop : | release internal vars
refresh : | pass control to GUI for refresh
pbar : | refresh progress bar
label : | refresh label
Return value : |

### CalcInfos

CalcModel model;

A structure used to pass arguments. /

os : | OS version like "3.01"
bios : | BIOS (boot) version like 2.01
Return value : |

### CalcFncts

const int model;

A structure used for handling a hand-held. !!! This structure is for private use !!! /

model : | link cable model (CalcModel).
name : | name of hand-held like "TI89"
fullname : | complete name of hand-held like "TI-89"
description : | description of hand-held like "TI89 calculator"
features : | supported operations (CalcOperations)
counters : | defines which CalcUpdate counters have to be refreshed (indexed by CalcFnctsIdx)
is_ready : | check whether calculator is ready
send_key : | send key value
execute : | remotely execute a program or application
recv_screen : | request a screendump
get_dirlist : | request a listing of variables, folders (if any) and apps (if any)
send_backup : | send a backup
recv_backup : | request a backup
send_var : | send a variable (silent mode)
recv_var : | request a variable silent mode)
send_var_ns : | send a variable (non-silent mode)
recv_var_ns : | receive a variable (non-silent mode)
send_flash : | send a FLASH app/os
recv_flash : | request a FLASH app/os
recv_idlist : | request hand-held IDLIST
dump_rom_1 : | dump the hand-held ROM: send dumper (if any)
dump_rom_2 : | dump the hand-held ROM: launch dumper
set_clock : | set date/time
get_clock : | get date/time
del_var : | delete variable
new_fld : | create new folder (if supported)
get_version : | returns Boot code & OS version
send_cert : | send certificate stuff
recv_cert : | receive certificate stuff
rename_var : | rename a variable
change_attr : | change attributes of a variable
send_all_vars_backup : | send a fake backup (set of files and FlashApps)
recv_all_vars_backup : | request a fake backup (set of files and FlashApps)
Return value : |

### CalcEventType

CALC_EVENT_TYPE_UNKNOWN = 0,

Defines the various events fired by libticalcs into a registered event hook, if any.

Return value : |

### CalcEventData

unsigned int version;

Information returned for every event fired by the libticalcs library; only a subset of the fields is valid for some event types.

version : | event protocol version.
type : | event type.
retval : | return value of the operation, for "after" events.
attached : | whether the cable is attached.
operation : | index (CalcFnctsIdx) of the generic operation invoked by the library user, if any.
data : | packet data to be sent / received, if any - or user-specified data.
Return value : |

### CalcHandle

CalcModel model;

A structure used to store information as a handle. !!! This structure is for private use !!! /

model : | cable model
calc : | calculator functions
update : | callbacks for GUI interaction
unused1 : | unused member kept for API compatibility purposes
buffer : | allocated data buffer for internal use
buffer2 : | allocated data buffer for internal use
open : | device has been opened
busy : | transfer is in progress
cable : | handle on cable used with this model
attached : | set if a cable has been attached
priv : | private per-handle data
event_hook : | callback fired upon various events (replaces and expands on the deprecated callbacks).
user_pointer : | user-set pointer passed to the event callbacks.
event_count : | number of events sent since this handle was created.
Return value : |

### DeviceOptions

CableModel cable_model;

A convenient structure free of use by the user. /

cable_model : | model
cable_port : | port
cable_timeout : | timeout in tenth of seconds
cable_delay : | inter-bit delay in µs
calc_model : | calculator model
Return value : |

### Return to the main index